(module arrayval (lib "eopl.ss" "eopl")
  
  (require "drscheme-init.scm")
  (require "store.scm")
  
  (provide (all-defined))
  
  (define mutarray?
    (lambda (v)
      (reference? v)))

  (define make-array
    (lambda (vals)
      (let ((ref (newref (length vals))))
        (map newref vals)
        ref)))
  
  (define arrayref
    (lambda (a i)
      (deref (getindex a i))))

  (define arrayset
    (lambda (a i val)
      (setref! (getindex a i) val)))
  
  (define getindex
    (lambda (a i)
      (cond
        [(< i 0) (eopl:error "array index out of bounds")]
        [(>= i (deref a)) (eopl:error "array index out of bounds")]
        [else (+ a (+ i 1))])))
  
  )

